#ifndef BatchLab_amanip_h
#define BatchLab_amanip_h

namespace Slash {namespace Core {class IWriter;}}
namespace AIDA {
  class ITuple;
  class IManagedObject;
  class IFilter;
  class IEvaluator;
  class IHistogram1D;
  class IHistogram2D;
  class IProfile1D;
  class IFunction;
  class ICloud;
  class IDataPointSet;
  class IBaseHistogram;
}
namespace Lib {class Out;}

#include <string>
#include <vector>

namespace BatchLab {

class amanip {
public:
  static bool is_column_type(const std::string&); 
  static bool compatible_tuples(Slash::Core::IWriter&,const AIDA::ITuple&,const AIDA::ITuple&); 
  static bool copy_tuple(Slash::Core::IWriter&,AIDA::ITuple&,AIDA::ITuple&); 
  static bool copy_tuple_filtered(Slash::Core::IWriter&,AIDA::ITuple&,AIDA::ITuple&,AIDA::IFilter&); 
  static bool tuple_getDouble(Slash::Core::IWriter&,const AIDA::ITuple&,int,double&); 
  static bool tuple_getString(Slash::Core::IWriter&,const AIDA::ITuple&,int,std::string&); 
  static bool tuple_fill(Slash::Core::IWriter&,AIDA::ITuple&,int,const std::string&); 
  static std::string managed_object_type(const AIDA::IManagedObject&); 
  static std::string managed_object_title(const AIDA::IManagedObject&); 
  static bool tuple_getBooking(Slash::Core::IWriter&,const AIDA::ITuple&,std::string&); 
  static std::string tuple_name(const AIDA::ITuple&);
  static bool tuple_evaluateMinMax(Slash::Core::IWriter&,AIDA::ITuple&,AIDA::IEvaluator&,AIDA::IFilter&,double&,double&,std::vector<double>* = 0);

  static void hprint(const AIDA::IHistogram1D&,const std::string&,Slash::Core::IWriter&);
  static void hprint(const AIDA::IHistogram2D&,const std::string&,Slash::Core::IWriter&);
  static void hprint(const AIDA::IProfile1D&,const std::string&,Slash::Core::IWriter&);
  static void hprint(const AIDA::ITuple&,const std::string&,Slash::Core::IWriter&);
  static void hprint(const AIDA::IFunction&,const std::string&,Slash::Core::IWriter&);
  static void hprint(const AIDA::ICloud&,const std::string&,Slash::Core::IWriter&);
  static void hprint(const AIDA::IDataPointSet&,const std::string&,Slash::Core::IWriter&);
  static void hprint(const AIDA::IBaseHistogram&,const std::string&,Slash::Core::IWriter&);
  static void hprint(const AIDA::IManagedObject&,Slash::Core::IWriter&);

  static bool write(AIDA::ITuple&,Lib::Out&,bool,bool,Slash::Core::IWriter&);
  static bool write(const AIDA::IHistogram1D&,Lib::Out&,bool,bool);
  static bool write(const AIDA::IHistogram2D&,Lib::Out&,bool,bool);

  static std::string binToString(int);
  static std::string d2s(double);
};
              
}

#endif
