#ifndef Lib_SpaceAlgebra_h
#define Lib_SpaceAlgebra_h 

#include <Lib/A3s.h>

namespace Lib {

class SpaceLine {
public:
  SpaceLine();
  SpaceLine(const A3d&,const A3d&);
  void setValue(const A3d&,const A3d&);
  const A3d& position() const;
  const A3d& direction() const;
private:
  A3d fPos;
  A3d fDir;
};

class SpacePlane {
public:
  SpacePlane();
  SpacePlane(const A3d&,const A3d&,const A3d&);
  SpacePlane(const A3d&,double);
  SpacePlane(const A3d&,const A3d&);
  void offset(double);
  bool intersect(const SpaceLine&,A3d&) const;
  bool isInHalfSpace(const A3d&) const;
  const A3d& normal() const;
  double distanceFromOrigin() const;
private:
  A3d fNormal;
  double fDistance;
};

}

#endif

